=== debian/changelog ===
openlayer (2.1-2.1build2) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:22:04 +0100

openlayer (2.1-2.1build1) yakkety; urgency=medium

  * No-change rebuild for libpng soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 23 Apr 2016 00:17:55 +0000

openlayer (2.1-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix "FTBFS with libpng16" -- new library requires some includes
    and has API change. (Closes: #809870)

 -- Tobias Frost <tobi@debian.org>  Sun, 24 Jan 2016 13:26:24 +0100

openlayer (2.1-2) unstable; urgency=medium

  * upgraded the dependency on libpng-dev. Closes: #809870
  * removed the obsoleted dependency on hardening-wrapper and activated
    dpkg-buildflags features

 -- Georges Khaznadar <georgesk@debian.org>  Sat, 09 Jan 2016 17:33:38 +0100

openlayer (2.1-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename library packages for g++5 ABI transition (closes: 791228).

 -- Julien Cristau <jcristau@debian.org>  Sun, 16 Aug 2015 17:51:28 +0200

openlayer (2.1-1) unstable; urgency=low

  * Initial release (Closes: #735016)
  * modified files related to src/Collisions.cpp, in order to prevent
    a compilation error for recent versions of g++ (mainly made more explicit
    a typedef based on templates).
  * modified CMakefile.txt to follow the Debian Policy for shared libraries
  * fixed an error to make possible the hardening options
  * improved the file d/copyright, thanks to Thorsten Alteholz 
    <ftpmaster@ftp-master.debian.org>

 -- Georges Khaznadar <georgesk@debian.org>  Mon, 06 Jan 2014 14:33:43 +0100
