=== debian/control ===
Source: openlayer
Section: devel
Priority: extra
Maintainer: Georges Khaznadar <georgesk@debian.org>
Build-Depends: debhelper (>= 8.0.0), cmake,
 zlib1g-dev, libpng-dev, liballegro4-dev, libxext-dev, libx11-dev, 
 liballeggl4-dev, libgl1-mesa-dev, libglu1-mesa-dev,
 libfreetype6-dev
Standards-Version: 3.9.5
Homepage: http://openlayer.berlios.de/

Package: libopenlayer2v5
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: libopenlayer2
Replaces: libopenlayer2
Description: hardware accelerated 2D Graphics library
 OpenLayer is a hardware accelerated 2D Graphics library. It specifies
 a new api to be used alongside of Allegro and takes control of how
 the contents of the screen are rendered and uses OpenGL functions
 through AllegroGL to allow hardware acceleration.

Package: libopenlayer-dev
Section: libdevel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libopenlayer2v5 (= ${binary:Version})
Description: hardware accelerated 2D Graphics library : development files
 OpenLayer is a hardware accelerated 2D Graphics library. It specifies
 a new api to be used alongside of Allegro and takes control of how
 the contents of the screen are rendered and uses OpenGL functions
 through AllegroGL to allow hardware acceleration.
